Subject: Message Passing not for the masses

From: [email-masked] (Harry Berryman)
Date: Thu, 11 Mar 1993 12:19:51 -0500

Al say's
  I do not reject this in fact I applaud your suggestion.
  This may be the only way we can get MPI-1 off the ground.
  I am a big advocate of maximizing ease of use
  this is only way to get the large user base necessary
  for MPI to become a standard.

\begin{flame}
I generally agree with Al, but not this time. While I tend to 
think that there should be some way to figure out how to use 
MPI in one sitting, I certainly do not think that we should 
be "maximizing ease of use" as the principle design goal. 
If I wanted things to be simple and slow, I'd be a Linda user.
Message passing is nasty. Message passing sucks. Message passing is
the way to get machines to go fast, at least for the time being.
\end{flame}

That being said,
even if MPI turns into a huge, ugly mass of routines, it should still 
be possible to isolate a few of these routines and present them 
as the "simple subset" for people who don't need to drive their 
communication costs down. I don't see "limiting the size of" being 
the same as "making easy to use". 

-scott berryman

---

From: David Levine <[email-masked]>
Date: Thu, 11 Mar 93 12:00:00 CST

X-Resent-To: [email-masked] ; Thu, 11 Mar 1993 12:19:57 EST
   Date: Thu, 11 Mar 1993 12:19:51 -0500
   From: [email-masked] (Harry Berryman)

   Al say's

   \begin{flame}
   :

I'd like to add my two cents in agreement with this comment.  Message passing
is NOT for the masses.  Its just too hard and grungy.  My opinion is that
message passing is the assembly language of parallel programming and it will
evolve that way.  I think the "large user base necessary for MPI to become a
standard." will be *expert* users, vendors, and HPF compiler writers. If MPI
doesn`t support what they need it will not be useful (it may still, however,
become yet-another-standard.)

That said, I am in agreement that there should be an easy-to-use MPI layer and
a nice tutorial document for novice users, but don't handicap MPI to
accomodate novice users who will migrate away from message-passing as
higher-level software tools (HPF, MIMDizer, BlockComm, ....) become available.

--dave levine